const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Media_assetsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const media_assets = await db.media_assets.create(
      {
        id: data.id || undefined,

        url: data.url || null,
        type: data.type || null,
        width: data.width || null,
        height: data.height || null,
        size_bytes: data.size_bytes || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await media_assets.setUser(data.user || null, {
      transaction,
    });

    await media_assets.setOrganizations(data.organizations || null, {
      transaction,
    });

    return media_assets;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const media_assetsData = data.map((item, index) => ({
      id: item.id || undefined,

      url: item.url || null,
      type: item.type || null,
      width: item.width || null,
      height: item.height || null,
      size_bytes: item.size_bytes || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const media_assets = await db.media_assets.bulkCreate(media_assetsData, {
      transaction,
    });

    // For each item created, replace relation files

    return media_assets;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const media_assets = await db.media_assets.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.url !== undefined) updatePayload.url = data.url;

    if (data.type !== undefined) updatePayload.type = data.type;

    if (data.width !== undefined) updatePayload.width = data.width;

    if (data.height !== undefined) updatePayload.height = data.height;

    if (data.size_bytes !== undefined)
      updatePayload.size_bytes = data.size_bytes;

    updatePayload.updatedById = currentUser.id;

    await media_assets.update(updatePayload, { transaction });

    if (data.user !== undefined) {
      await media_assets.setUser(
        data.user,

        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await media_assets.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return media_assets;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const media_assets = await db.media_assets.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of media_assets) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of media_assets) {
        await record.destroy({ transaction });
      }
    });

    return media_assets;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const media_assets = await db.media_assets.findByPk(id, options);

    await media_assets.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await media_assets.destroy({
      transaction,
    });

    return media_assets;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const media_assets = await db.media_assets.findOne(
      { where },
      { transaction },
    );

    if (!media_assets) {
      return media_assets;
    }

    const output = media_assets.get({ plain: true });

    output.user = await media_assets.getUser({
      transaction,
    });

    output.organizations = await media_assets.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.users,
        as: 'user',

        where: filter.user
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.user
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  firstName: {
                    [Op.or]: filter.user
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.url) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('media_assets', 'url', filter.url),
        };
      }

      if (filter.widthRange) {
        const [start, end] = filter.widthRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            width: {
              ...where.width,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            width: {
              ...where.width,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.heightRange) {
        const [start, end] = filter.heightRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            height: {
              ...where.height,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            height: {
              ...where.height,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.size_bytesRange) {
        const [start, end] = filter.size_bytesRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            size_bytes: {
              ...where.size_bytes,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            size_bytes: {
              ...where.size_bytes,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.type) {
        where = {
          ...where,
          type: filter.type,
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.media_assets.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('media_assets', 'url', query),
        ],
      };
    }

    const records = await db.media_assets.findAll({
      attributes: ['id', 'url'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['url', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.url,
    }));
  }
};
